ipython
~ % ipython
from FoxDot import *
Python 3.8.1 (default, Jan 22 2020, 06:38:00)
Type 'copyright', 'credits' or 'license' for more information
IPython 7.12.0 -- An enhanced Interactive Python. Type '?' for help.

In [1]: from FoxDot import *

In [2]: Scale.default = Scale.minorPentatonic

In [3]: Root.default = "A"

In [4]: Clock.bpm = 140

In [5]: p2 >> dbass(dur=.5, oct=4, amp=.6)
Out[5]: <p2 - dbass>

In [6]: p2 >> dbass(dur=.5, oct=4, amp=.6)
Out[6]: <p2 - dbass>

In [7]: p1 >> blip([0,1,2,3], amplify=var([1,0], [28,4]))
Out[7]: <p1 - blip>

In [8]: x1 >> play("V ", dur=.5)
Out[8]: <x1 - play2>

In [9]: x2 >> play(" |n2|", dur=.5)
Out[9]: <x2 - play2>

In [10]: x1 >> play("V ", dur=.5)
Out[10]: <x1 - play2>

In [11]: x2 >> play(" |n2|", dur=.5)
Out[11]: <x2 - play2>

In [12]: x3 >> play(" |*1", dur=1)
---------------------------------------------------------------------------
ValueError                                Traceback (most recent call last)
<ipython-input-12-f6acedc3d0ad> in <module>
----> 1 x3 >> play(" |*1", dur=1)

~/.local/lib/python3.8/site-packages/FoxDot/lib/Players.py in __rshift__(self, *args, **kwargs)
    164         self.__class__ = Player
    165         self.__init__(self.name)
--> 166         self.__rshift__(*args, **kwargs)
    167         return self
    168

~/.local/lib/python3.8/site-packages/FoxDot/lib/Players.py in __rshift__(self, other)
    377             # Call the update method
    378
--> 379             self.update(other.name, other.degree, **other.kwargs)
    380
    381             # self.update_pattern_root('sample' if self.synthdef == SamplePlayer else 'degree')

~/.local/lib/python3.8/site-packages/FoxDot/lib/Players.py in update(self, synthdef, degree, **kwargs)
    832             if degree is not None:
    833
--> 834                 setattr(self, "degree", degree if degree != "" else " ")
    835
    836         elif degree is not None:

~/.local/lib/python3.8/site-packages/FoxDot/lib/Players.py in __setattr__(self, name, value)
    458                 name = self.alias.get(name, name)
    459
--> 460                 value = asStream(value)
    461
    462                 for item in value:

~/.local/lib/python3.8/site-packages/FoxDot/lib/Patterns/Main.py in asStream(data)
   1494 def asStream(data):
   1495     """ Forces any data into a [pattern] form """
-> 1496     return data if isinstance(data, Pattern) else Pattern(data)
   1497
   1498 def PatternFormat(data):

~/.local/lib/python3.8/site-packages/FoxDot/lib/Patterns/Main.py in __init__(self, *args)
     95             if type(data) is str:
     96
---> 97                 self.fromString(data)
     98
     99             elif type(data) is tuple:

~/.local/lib/python3.8/site-packages/FoxDot/lib/Patterns/Parse.py in fromString(self, string)
    261 @PatternMethod
    262 def fromString(self, string):
--> 263     self.data = ParsePlayString(string)
    264     self.make()
    265     return self

~/.local/lib/python3.8/site-packages/FoxDot/lib/Patterns/Parse.py in ParsePlayString(string, flat)
     27 def ParsePlayString(string, flat=False):
     28     """ Returns the parsed play string used by sample player """
---> 29     output, _ = feed(string)
     30     return output
     31

~/.local/lib/python3.8/site-packages/FoxDot/lib/Patterns/Parse.py in feed(string)
    124
    125             # Parse the contents of the brackets if found
--> 126             j = string.next_char_index("|", start=i+1)
    127             s = string[i+1:j]
    128             i = j

~/.local/lib/python3.8/site-packages/FoxDot/lib/Patterns/PlayString.py in next_char_index(self, char, start)
     50     def next_char_index(self, char, start=0):
     51         try:
---> 52             return self.string[start:].index(char) + start
     53         except IndexError:
     54             raise ParseError("No {!r} character found in string {!r}".format(char, self.original))

ValueError: '|' is not in list

In [13]: x1 >> play("V ", dur=.5)
Out[13]: <x1 - play2>

In [14]: x2 >> play(" |n2|", dur=.5)
Out[14]: <x2 - play2>

In [15]: x3 >> play(" |*1|", dur=1)
Out[15]: <x3 - play2>

In [16]: p2 >> dbass(dur=[.5,1,.5,.5], oct=4, amp=.6)
Out[16]: <p2 - dbass>

In [17]: p1 >> blip([0,1,2,3], amplify=var([1,0], [28,4]))
Out[17]: <p1 - blip>

In [18]: p3 >> arpy(amp=linvar([.6, 1]), dur=PDur(3,8))
Out[18]: <p3 - arpy>

In [19]: p3 >> arpy(amp=linvar([.9, 2]), dur=PDur(3,8)
    ...: x1 >> play("V ", dur=.5, amp=.7)
    ...: x2 >> play(" |n2|", dur=.5, amp=.7)
    ...: x3 >> play(" |*1|", dur=1, amp=.7)
    ...:
    ...:
  File "<ipython-input-19-570df5dde345>", line 2
    x1 >> play("V ", dur=.5, amp=.7)
    ^
SyntaxError: invalid syntax


In [20]: p3 >> arpy(amp=linvar([.9, 2]), dur=PDur(3,8))
Out[20]: <p3 - arpy>

In [21]: x1 >> play("V ", dur=.5, amp=.7)
Out[21]: <x1 - play2>

In [22]: x2 >> play(" |n2|", dur=.5, amp=.7)
Out[22]: <x2 - play2>

In [23]: x3 >> play(" |*1|", dur=1, amp=.7)
Out[23]: <x3 - play2>

In [24]: p3 >> arpy(amp=linvar([.9, 2]), dur=PDur(3,8), sus=var([2,6]))
Out[24]: <p3 - arpy>

In [25]: p3 >> arpy(amp=linvar([.9, 2]), dur=PDur(3,8), sus=var([2,6]), hpf=linvar([122,4000]))
Out[25]: <p3 - arpy>

In [26]: p2 >> dbass(dur=[.5,1,.5,.5], oct=4, amp=.6)
Out[26]: <p2 - dbass>

In [27]: p1 >> blip(P[0,2,4,6,8,10], slide=linvar([0,.6]), oct=[4,6], sus=.5)
Out[27]: <p1 - blip>

In [28]: p2 >> dbass(dur=[.5,1,.5,.5], oct=4, amp=.6)
Out[28]: <p2 - dbass>

In [29]: p1 >> blip(P[0,2,4,6,8,10], slide=linvar([0,.6]), oct=[4,6], sus=.5, amp=1.5)
Out[29]: <p1 - blip>

In [30]: p2 >> dbass(dur=[.5,1,.5,.5], oct=4, amp=.6).slider()
Out[30]: <p2 - dbass>

In [31]: p1 >> blip(P[0,2,4,6,8,10], slide=linvar([0,.6]), oct=[4,6], sus=.5, amp=1.5)
Out[31]: <p1 - blip>

In [32]: p3 >> arpy(amp=linvar([.9, 2]), dur=PDur(3,8), sus=var([2,6]), hpf=linvar([122,4000]), chop=4)
Out[32]: <p3 - arpy>

In [33]: p2 >> dbass(dur=[.5,1,.5,.5], oct=4, amp=.4).slider()
Out[33]: <p2 - dbass>

In [34]: p1 >> blip(P[0,2,4,6,8,10], slide=linvar([0,.6]), oct=[4,6], sus=.5, amp=1.5)
Out[34]: <p1 - blip>

In [35]: p3 >> arpy(amp=linvar([.9, 2]), dur=PDur(3,8), sus=var([2,6]), hpf=linvar([122,4000]), chop=8)
Out[35]: <p3 - arpy>

In [36]: p2 >> dbass(dur=[.5,1,.5,.5], oct=4, amp=.4).slider()
Out[36]: <p2 - dbass>

In [37]: p1 >> blip(P[0,2,4,6,8,10], slide=linvar([0,.6]), oct=[4,6], sus=.5, amp=1.5).every(6,5, "jump", cycle
    ...: =8)
Warning: 5 is not a valid method for type <class 'FoxDot.lib.Players.Player'>
Out[37]: <p1 - blip>

In [38]: p1 >> blip(P[0,2,4,6,8,10], slide=linvar([0,.6]), oct=[4,6], sus=.5, amp=1.5).every(6.5, "jump", cycle
    ...: =8)
Out[38]: <p1 - blip>

In [39]: b1 >> dirt(oct=4, dur=PDur(5,6))
Out[39]: <b1 - dirt>

In [40]: ~p2 >> dbass(dur=[.5,1,.5,.5], oct=4, amp=.4)
Out[40]: <p2 - dbass>

In [41]: p1 >> blip(P[0,2,4,6,8,10], slide=linvar([0,.6]), oct=[4,6], sus=.5, amp=1.5).every(6.5, "jump", cycle
    ...: =8)
Out[41]: <p1 - blip>

In [42]: p1.amplify = 1

In [43]: za >> zap(PSum(1,2), oct=4, amp=3, dur=PDur(8,8), vib=2)
Out[43]: <za - zap>

In [44]: za >> zap(PSum(1,2), oct=[4,4.3], amp=3, dur=PDur(8,8), vib=2)
Out[44]: <za - zap>

In [45]: za >> zap(PSum(1,2), oct=[4,4.3], amp=3, dur=PDur(7,8), vib=2)
Out[45]: <za - zap>

In [46]: ~p2 >> dbass(dur=[.5,1,.5,.5], oct=4, amp=.4)
Out[46]: <p2 - dbass>

In [47]: p1 >> blip(P[0,2,4,6,8,10], slide=linvar([0,.6]), oct=[4,6], sus=.5, amp=.5).every(6.5, "jump", cycle=
    ...: 8)
Out[47]: <p1 - blip>

In [48]: za >> zap(PSum(1,2), oct=linvar([4,4.3]), amp=3, dur=PDur(7,8), vib=2)
Out[48]: <za - zap>

In [49]: za >> zap(PSum(1,2), oct=linvar([4,4.3]), amp=3, dur=PDur(8,8), vib=2)
Out[49]: <za - zap>

In [50]: x_all.amp =.6

In [51]: za >> zap(PSum(1,2), oct=linvar([4,4.3]), amp=3, dur=PDur(7,8), vib=2)
Out[51]: <za - zap>

In [52]: p3 >> arpy(amp=linvar([.6, 1.5]), dur=PDur(3,8), sus=var([2,6]), hpf=linvar([122,4000]), chop=8)
Out[52]: <p3 - arpy>

In [53]: px >> pluck(var([0,3,2,4,1]), pan=[1,-1], dur=[1,.25,.25,.5])
Out[53]: <px - pluck>

In [54]: px >> pluck(var([0,3,2,4,1], 8), amp=1.2, pan=[1,-1], dur=[1,.25,.25,.5])
Out[54]: <px - pluck>

In [55]: px >> pluck(var([0,3,2,4,1], 8), amp=1.5, pan=[1,-1], dur=[1,.25,.25,.5])
Out[55]: <px - pluck>

In [56]: za >> zap(PSum(1,2), oct=linvar([4,4.3]), amp=2, dur=PDur(7,8), vib=2)
Out[56]: <za - zap>

In [57]: px >> pluck(var([0,3,2,4,1], 8), amp=1.5, pan=[1,-1], dur=[1,.25,.25,.5]) + (0,2,4)
Out[57]: <px - pluck>

In [58]: px >> pulse([0,2,[4,6,7],[3,5,1],(4,2,0)], dur=PDur(5,9))
Out[58]: <px - pulse>

In [59]: ~px >> pulse([0,2,[4,6,7],[3,5,1],(4,2,0)], dur=PDur(5,9))
Out[59]: <px - pulse>

In [60]: ~px >> pulse([0,2,[4,6,7],[3,5,1],(4,2,0)], dur=PDur(5,9), amp=1.5, sus=2, chop=4)
Out[60]: <px - pulse>

In [61]: ~px >> pulse([0,2,[4,6,7],[3,5,1],(4,2,0)], dur=PDur(5,9), amp=1.2, sus=2, chop=4)
Out[61]: <px - pulse>

In [62]: ~px >> pulse([0,2,[4,6,7],[3,5,1],(4,2,0)], dur=PDur(5,9), amp=1.2, sus=2, chop=4, oct=[4,5])
Out[62]: <px - pulse>

In [63]: ~px >> pulse([0,2,[4,6,7],[3,5,1],(4,2,0)], dur=PDur(5,9), amp=1.2, sus=1, chop=8, oct=[4,5])
Out[63]: <px - pulse>

In [64]: ~px >> pulse([0,2,[4,6,7],[3,5,1],(4,2,0)], dur=PDur(5,9), amp=1.2, sus=1, chop=4, oct=[4,5])
Out[64]: <px - pulse>

In [65]: x_all.stop()

In [66]: ~p3 >> play("X ", amp=.6)
Out[66]: <p3 - play2>

In [67]: ~p2 >> play("<V >< [**] [**] * *>< |o1|>")
Out[67]: <p2 - play2>

In [68]: x_all.stop()

In [69]: ~p3 >> play("X ", amp=.6)
Out[69]: <p3 - play2>

In [70]: ~p2 >> play("<V >< [**] [**]>< |o1|>")
Out[70]: <p2 - play2>

In [71]: x_all.stop()

In [72]: ~p3 >> play("X ", amp=.6)
Out[72]: <p3 - play2>

In [73]: ~p2 >> play("<V >< [**] [**]>")
Out[73]: <p2 - play2>

In [74]: x_all.stop()

In [75]: ~p3 >> play("X ", amp=.6)
Out[75]: <p3 - play2>

In [76]: ~p2 >> play("[**]")
Out[76]: <p2 - play2>

In [77]: p1.stop()
Out[77]: <p1 - blip>

In [78]: p2.stop()
Out[78]: <p2 - play2>

In [79]: p3.stop()
Out[79]: <p3 - play2>

In [80]: ~px >> karp([0,2,[4,6,7],[3,5,1],(4,2,0)], dur=PDur(3,9), amp=1.2, sus=2, chop=4, oct=[4,5])
Out[80]: <px - karp>

In [81]: x1 >> play("V ", dur=.5, amp=.7)
Out[81]: <x1 - play2>

In [82]: x2 >> play(" |n2|", dur=.5, amp=.7)
Out[82]: <x2 - play2>

In [83]: x3 >> play(" |*1|", dur=1, amp=.7)
Out[83]: <x3 - play2>

In [84]: ~p3 >> sinepad(amp=linvar([.6, 1.5]), dur=PDur(3,8)*(1,2), sus=var([2,6]), hpf=linvar([122,4000]), cho
    ...: p=8)
Out[84]: <p3 - sinepad>

In [85]: ~p3 >> sinepad(amp=linvar([.6, 2]), dur=PDur(3,8)*(1,2), sus=var([2,6]), hpf=linvar([122,4000]), chop=
    ...: 8)
Out[85]: <p3 - sinepad>

In [86]: ~p3 >> sinepad(amp=linvar([.9, 3]), dur=PDur(3,8)*(1,2), sus=var([2,6]), hpf=linvar([122,4000]), chop=
    ...: 8)
Out[86]: <p3 - sinepad>

In [87]: p1.stop()
Out[87]: <p1 - blip>

In [88]: p2.stop()
Out[88]: <p2 - play2>

In [89]: p3.stop()
Out[89]: <p3 - sinepad>

In [90]: ~px >> karp([0,2,[4,6,7],[3,5,1],(4,2,0)], dur=PDur(3,9), amp=.9, sus=2, chop=4, oct=[4,5])
Out[90]: <px - karp>

In [91]: ~p3 >> sinepad(amp=linvar([.9,3]), dur=PDur(3,8)*(1,2), sus=var([2,6]), hpf=linvar([122,4000]), chop=8
    ...: )
Out[91]: <p3 - sinepad>

In [92]: ~p3 >> sinepad(amp=linvar([1.2,4]), dur=PDur(3,8)*(1,2), sus=var([2,6]), hpf=linvar([122,4000]), chop=
    ...: 8)
Out[92]: <p3 - sinepad>

In [93]: ~p2 >> dbass(dur=PDur(7,9), oct=[3,5,4], amp=.6)
Out[93]: <p2 - dbass>

In [94]: za >> zap(PSum(1,2), oct=linvar([4,4.3]), amp=1.5, dur=PDur(7,8)|2, vib=2)
Out[94]: <za - zap>

In [95]: ~p3 >> nylon(amp=1, dur=PDur(5,8)*(1,2), oct=3, sus=var([2,6]), hpf=linvar([122,4000]), chop=8)
Out[95]: <p3 - nylon>

In [96]: ~p3 >> nylon(amp=1.3, dur=PDur(5,8)*(1,2), oct=3, sus=var([2,6]), hpf=linvar([122,4000]), chop=8)
Out[96]: <p3 - nylon>

In [97]: ~p3 >> nylon(amp=1.5, dur=PDur(5,8)*(1,2), oct=3, sus=var([2,6]), hpf=linvar([122,4000]), chop=8)
Out[97]: <p3 - nylon>

In [98]: ~p3 >> nylon(amp=1.5, dur=PDur(5,8)*(1,2), oct=3, sus=var([2,6]), hpf=linvar([122,4000]), chop=4)
Out[98]: <p3 - nylon>

In [99]: ~p2 >> jbass(dur=PDur(7,9), oct=[3,5,4], amp=.6).slider()
Out[99]: <p2 - jbass>

In [100]: ~p2 >> jbass(dur=PDur(7,9), oct=[3,5,4], amp=.7).slider()
Out[100]: <p2 - jbass>

In [101]: ~p3 >> nylon(amp=1.5, dur=PDur(5,8)*(1,2), oct=3, sus=var([2,6]), hpf=linvar([122,4000]), chop=8)
Out[101]: <p3 - nylon>

In [102]: ~p3 >> nylon(amp=1.5, dur=PDur(7,8)*(1,2), oct=3, sus=var([2,6]), hpf=linvar([122,4000]), chop=8)
Out[102]: <p3 - nylon>

In [103]: ~b1 >> dirt(oct=5, dur=PDur(5,6))
Out[103]: <b1 - dirt>

In [104]: ~p2 >> jbass(dur=PDur(7,9), oct=[3,5,4], amp=.3).slider()
Out[104]: <p2 - jbass>

In [105]: ~p3 >> nylon(amp=1.5, dur=PDur(5,8)*(1,2), oct=3, sus=var([2,6]), hpf=linvar([122,4000]), chop=8)
Out[105]: <p3 - nylon>

In [106]: px.stop()
Out[106]: <px - karp>

In [107]: za.stop()
Out[107]: <za - zap>

In [108]: ~p3 >> nylon(amp=1.5, dur=PDur(5,8)*(1,2), oct=[3,4], sus=var([2,6]), hpf=linvar([122,4000]), chop=8)
     ...:
Out[108]: <p3 - nylon>

In [109]: ~p3 >> nylon(amp=1.5, dur=PDur(5,8)*(1,2), oct=[3,4], sus=var([2,6]), hpf=linvar([122,4000]), chop=4)
     ...:
Out[109]: <p3 - nylon>

In [110]: ~p3 >> nylon(amp=1.5, dur=PDur(3,8)*(1,2), oct=[3,4], sus=var([2,6]), hpf=linvar([122,4000]), chop=8)
     ...:
Out[110]: <p3 - nylon>

In [111]: ~p3 >> nylon(amp=1.5, dur=PDur(3,8)*(1,2), oct=[3,4,5], sus=var([2,6]), hpf=linvar([122,4000]), chop=
     ...: 8)
Out[111]: <p3 - nylon>

In [112]: ~p3 >> nylon(amp=1.5, dur=PDur(3,8), oct=[3,4,5], sus=var([2,6]), hpf=linvar([122,4000]), chop=8)
Out[112]: <p3 - nylon>

In [113]: ~b1 >> dirt(oct=5, dur=PDur(5,8))
Out[113]: <b1 - dirt>

In [114]: p2.stop()
Out[114]: <p2 - jbass>

In [115]: ~p3 >> nylon(amp=1.5, dur=PDur(3,8), oct=[3,4,5], sus=var([2,6]), hpf=linvar([122,4000]), chop=2)
Out[115]: <p3 - nylon>

In [116]: ~b1 >> dirt(oct=6, dur=PDur(5,8))
Out[116]: <b1 - dirt>

In [117]: ~b1 >> dirt(oct=[6,5], dur=PDur(5,8))
Out[117]: <b1 - dirt>

In [118]: ~b1 >> dirt(oct=[6,5], dur=PDur(7,8))
Out[118]: <b1 - dirt>

In [119]: ~p3 >> nylon(amp=1, dur=PDur(3,8), oct=[3,4,5], sus=var([2,6]), hpf=linvar([122,4000]), chop=2)
Out[119]: <p3 - nylon>

In [120]: ~b1 >> dirt(oct=[6,5], amp=1.2, dur=PDur(7,8))
Out[120]: <b1 - dirt>

In [121]: ~b1 >> dirt(oct=[6,5], amp=1.2, dur=PDur(8,8))
Out[121]: <b1 - dirt>

In [122]: ~b1 >> dirt(oct=[6,5], amp=1.2, dur=PDur(8,9))
Out[122]: <b1 - dirt>

In [123]: ~b1 >> dirt(oct=[6,5], amp=1.2, dur=PDur(8,9)|2)
Out[123]: <b1 - dirt>

In [124]: ~b1 >> dirt(oct=[6,5], amp=1.2, dur=PDur(8,9))
Out[124]: <b1 - dirt>

In [125]: ~b1 >> dirt(oct=[6,5], amp=1.2, dur=PDur(7,9))
Out[125]: <b1 - dirt>

In [126]: ~p3 >> nylon(amp=1, dur=PDur(3,8), oct=[3,4,5], sus=var([2,6]), hpf=linvar([122,4000]), chop=4)
Out[126]: <p3 - nylon>

In [127]: ~p3 >> nylon(amp=1, dur=PDur(3,9), oct=[3,4,5], sus=var([2,6]), hpf=linvar([122,4000]), chop=4)
Out[127]: <p3 - nylon>

In [128]: ~p3 >> nylon(amp=1, dur=PDur(3,9), oct=[4,5,6], sus=var([2,6]), hpf=linvar([122,4000]), chop=4)
Out[128]: <p3 - nylon>

In [129]: ~b1 >> dirt(oct=[6,5], amp=1.2, dur=PDur(5,9))
Out[129]: <b1 - dirt>

In [130]: ~p3 >> nylon(amp=1, dur=PDur(3,9), oct=[4,5,6], sus=var([2,6]), hpf=linvar([122,4000]), chop=8)
Out[130]: <p3 - nylon>

In [131]: ~b1 >> dirt(oct=[6,5], amp=1.2, dur=PDur(7,9))
Out[131]: <b1 - dirt>

In [132]: ~b1 >> dirt(oct=[6,5], amp=1.2, dur=PDur(7,9)*(1,2))
Out[132]: <b1 - dirt>

In [133]: ~b1 >> dirt(oct=[6,5], amp=1.2, dur=PDur(7,8)*(1,2))
Out[133]: <b1 - dirt>

In [134]: ~b1 >> dirt(oct=[6,5], amp=1.2, dur=PDur(3,8))
Out[134]: <b1 - dirt>

In [135]: ~b1 >> dirt(oct=[6,5], amp=1.2, dur=PDur(3,8)|2)
Out[135]: <b1 - dirt>

In [136]: ~b1 >> dirt(oct=[6,5], amp=1.2, dur=PDur(1,8)|2)
Out[136]: <b1 - dirt>

In [137]: ~p3 >> nylon(amp=1, dur=PDur(3,9), oct=[4,5,6], sus=var([2,6]), hpf=linvar([122,4000]), chop=1)
Out[137]: <p3 - nylon>

In [138]: b1.stop()
Out[138]: <b1 - dirt>

In [139]: x_all.stop()

In [140]: Clock.clear()

In [141]:
