In [2]: Scale.default = Scale.minorPentatonic

In [3]: Root.default = "A"

In [4]: Clock.bpm = 140

In [5]:

In [5]: p2 >> dbass(dur=.5, oct=4, amp=.7)
Out[5]: <p2 - dbass>

In [6]: p1 >> pulse([0,1,2,3], amplify=var([1,0], [28,4]), sus=.5)
Out[6]: <p1 - pulse>

In [7]: x1 >> play("V ", dur=.5)
Out[7]: <x1 - play2>

In [8]: x2 >> play(" |n2|", dur=.5)
Out[8]: <x2 - play2>

In [9]: x4 >> play(" |*1|", dur=1)
Out[9]: <x4 - play2>

In [10]: p1 >> pulse([0,1,2,3], amplify=1, sus=.5, chop=2)
Out[10]: <p1 - pulse>

In [11]: p3 >> pulse(oct=4, amp=linvar([.9,2]), dur=PDur(3,8), sus=.5)
Out[11]: <p3 - pulse>

In [12]: p3 >> pulse(oct=3, amp=linvar([.9,2]), dur=PDur(3,8), sus=.5)
Out[12]: <p3 - pulse>

In [13]: p2 >> dbass(dur=[.5,1,.5,.5], oct=4, amp=.7)
Out[13]: <p2 - dbass>

In [14]: p3 >> pulse(oct=3, amp=linvar([.9,2]), dur=PDur(3,8), sus=var([2,6]), hpf=linvar([122,4000]))
Out[14]: <p3 - pulse>

In [15]: p1 >> pulse([0,1,2,3], amplify=1, sus=.5, chop=4)
Out[15]: <p1 - pulse>

In [16]: p3 >> pulse(oct=3, amp=linvar([.9,2]), dur=PDur(3,8), sus=var([2,6]), hpf=linvar([122,4000]), chop
    ...: =4)
Out[16]: <p3 - pulse>

In [17]: p3 >> pulse(oct=3, amp=linvar([.9,2]), dur=PDur(3,8), sus=var([2,6]), hpf=linvar([122,4000]), chop
    ...: =8)
Out[17]: <p3 - pulse>

In [18]: p1 >> pulse([0,2,4,6,8,10], amplify=1, sus=.5, chop=4)
Out[18]: <p1 - pulse>

In [19]: p1 >> pulse([0,2,4,6,8,10], amplify=1, sus=.5, chop=4, oct=[4,6])
Out[19]: <p1 - pulse>

In [20]: p1 >> pulse([0,2,4,6,8,10], amplify=1, sus=.5, chop=8, oct=[4,6])
Out[20]: <p1 - pulse>

In [21]: p3 >> pulse(oct=3, amp=linvar([.9,2]), dur=PDur(3,8), sus=var([2,6]), hpf=linvar([122,4000]), chop
    ...: =6)
Out[21]: <p3 - pulse>

In [22]: p3 >> pulse(oct=2, amp=linvar([.9,2]), dur=PDur(3,8), sus=var([2,6]), hpf=linvar([122,4000]), chop
    ...: =6)
Out[22]: <p3 - pulse>

In [23]: p2 >> dbass(dur=[.5,1,.5,.5], oct=4, amp=.7).slider()
Out[23]: <p2 - dbass>

In [24]: p3 >> pulse(oct=[2,3], amp=linvar([.9,2]), dur=PDur(3,8), sus=var([2,6]), hpf=linvar([122,4000]),
    ...: chop=8)
Out[24]: <p3 - pulse>

In [25]: p1 >> pulse([0,2,4,6,8,10], amplify=1, sus=.5, chop=12, oct=[4,6])
Out[25]: <p1 - pulse>

In [26]: p1 >> pulse([0,2,4,6,8,10], amplify=1, sus=.5, chop=12, slide=linvar([0,.6]) oct=[4,6])
  File "<ipython-input-26-d2f7c434aa9e>", line 1
    p1 >> pulse([0,2,4,6,8,10], amplify=1, sus=.5, chop=12, slide=linvar([0,.6]) oct=[4,6])
                                                                                 ^
SyntaxError: invalid syntax


In [27]: p1 >> pulse([0,2,4,6,8,10], amplify=1, sus=.5, chop=12, slide=linvar([0,.6]), oct=[4,6])
Out[27]: <p1 - pulse>

In [28]: p1 >> pulse(P[0,2,4,6,8,10], amplify=1, sus=.5, chop=12, slide=linvar([0,.6]), oct=[4,6])
Out[28]: <p1 - pulse>

In [29]: p1 >> pulse(P[0,2,4,6,8,10], amplify=1, sus=.5, chop=12, slide=linvar([0,.6]), oct=6)
Out[29]: <p1 - pulse>

In [30]: p1 >> pulse(P[0,2,4,6,8,10], amplify=1, sus=.25, chop=12, slide=linvar([0,.6]), oct=6)
Out[30]: <p1 - pulse>

In [31]: p3 >> pulse(oct=[2,3], amp=linvar([.9,2]), dur=PDur(3,8), sus=var([1,4]), hpf=linvar([122,4000]),
    ...: chop=8)
Out[31]: <p3 - pulse>

In [32]: p2 >> dbass(dur=[.5,1,.5,.5], oct=4, amp=.4).slider()
Out[32]: <p2 - dbass>

In [33]: p3 >> pulse(oct=[2,3], amp=linvar([.9,2]), dur=PDur(5,8), sus=var([1,4]), hpf=linvar([122,4000]),
    ...: chop=8)
Out[33]: <p3 - pulse>

In [34]: p3 >> pulse(oct=[2,3], amp=linvar([.9,2]), dur=PDur(7,8), sus=var([1,4]), hpf=linvar([122,4000]),
    ...: chop=8)
Out[34]: <p3 - pulse>

In [35]: p3 >> pulse(oct=[2,3], amp=linvar([.9,2]), dur=PDur(5,8)*(1,2), sus=var([1,4]), hpf=linvar([122,40
    ...: 00]), chop=8)
Out[35]: <p3 - pulse>

In [36]: p3 >> pulse(oct=[2,3], amp=linvar([.9,2]), dur=PDur(5,8)*(1,2), sus=var([3,8]), hpf=linvar([122,40
    ...: 00]), chop=8)
Out[36]: <p3 - pulse>

In [37]: p3 >> pulse(oct=[2,3], amp=linvar([.9,2]), dur=PDur(5,8), sus=var([3,8]), hpf=linvar([122,4000]),
    ...: chop=8)
Out[37]: <p3 - pulse>

In [38]: p3 >> pulse(oct=[2,3], amp=linvar([.9,2]), dur=PDur(3,8), sus=var([3,8]), hpf=linvar([122,4000]),
    ...: chop=8)
Out[38]: <p3 - pulse>

In [39]: p2 >> dbass(dur=PDur(3,8), oct=4, amp=.4).slider()
Out[39]: <p2 - dbass>

In [40]: p3 >> pulse(oct=[2,3], amp=linvar([.9,2]), dur=PDur(5,8), sus=var([1,4]), hpf=linvar([122,4000]),
    ...: chop=8)
Out[40]: <p3 - pulse>

In [41]: b1 >> dirt(oct=4, dur=PDur(5,6))
Out[41]: <b1 - dirt>

In [42]: p3 >> pulse(oct=[2,3], amp=linvar([.9,2]), dur=PDur(3,8), sus=var([2,6]), hpf=linvar([122,4000]),
    ...: chop=8)
Out[42]: <p3 - pulse>

In [43]: p1 >> pulse(P[0,2,4,6,8,10], amplify=1, sus=.25, chop=8, slide=linvar([0,.6]), oct=6)
Out[43]: <p1 - pulse>

In [44]: ~p1 >> pulse(P[0,2,4,6,8,10], amplify=1, sus=.25, chop=8, slide=linvar([0,.6]), oct=6)
Out[44]: <p1 - pulse>

In [45]: p1 >> pulse(P[0,2,4,6,8,10], amplify=1, sus=.25, chop=8, slide=linvar([0,.6]), oct=6).sometimes("s
    ...: tutter")
Out[45]: <p1 - pulse>

In [46]: p1 >> pulse(P[0,2,4,6,8,10], sus=.25, chop=8, slide=linvar([0,.6]), oct=6).sometimes("stutter", 4)
    ...:
Out[46]: <p1 - pulse>

In [47]: p3 >> pulse(oct=[2,3], amp=linvar([.9,2]), dur=PDur(5,8), sus=var([2,6]), hpf=linvar([122,4000]),
    ...: chop=8)
Out[47]: <p3 - pulse>

In [48]: p3 >> pulse(oct=[2,4], amp=linvar([.9,2]), dur=PDur(5,8), sus=var([2,6]), hpf=linvar([122,4000]),
    ...: chop=8)
Out[48]: <p3 - pulse>

In [49]: p2 >> dbass(dur=PDur(3,8), oct=4, amp=.3).slider()
Out[49]: <p2 - dbass>

In [50]: p3 >> pulse(oct=[2,3], amp=linvar([.9,2]), dur=PDur(5,8), sus=var([2,6]), hpf=linvar([122,4000]),
    ...: chop=8)
Out[50]: <p3 - pulse>

In [51]: za >> zap(PSum(1,2), oct=4, amp=3, dur=PDur(8,8), vib=2)
Out[51]: <za - zap>

In [52]: za >> zap(PSum(1,2), oct=4, amp=3, dur=PDur(7,8), vib=2)
Out[52]: <za - zap>

In [53]: za >> zap(PSum(1,2), oct=4, amp=3, dur=PDur(7,8), vib=2, crush=2)
Out[53]: <za - zap>

In [54]: za >> zap(PSum(1,2), oct=4, amp=3, dur=PDur(7,8), vib=2, crush=4)
Out[54]: <za - zap>

In [55]: za >> zap(PSum(1,2), oct=4, amp=3, dur=PDur(7,8), vib=2, crush=8)
Out[55]: <za - zap>

In [56]: za >> zap(PSum(1,2), oct=4, amp=3, dur=PDur(7,8)|2, vib=2, crush=8)
Out[56]: <za - zap>

In [57]: p3 >> pulse(oct=[2,3], amp=linvar([.9,2]), dur=PDur(7,8), sus=var([2,6]), hpf=linvar([122,4000]),
    ...: chop=8)
Out[57]: <p3 - pulse>

In [58]: p1 >> pulse(P[0,2,4,6,8,10], sus=.25, chop=8, slide=linvar([0,.6]), oct=6).sometimes("stutter", 6)
    ...:
Out[58]: <p1 - pulse>

In [59]: p1 >> pulse(P[0,2,4,6,8,10], sus=.25, chop=8, slide=linvar([0,.6]), oct=5).sometimes("stutter", 6)
    ...:
Out[59]: <p1 - pulse>

In [60]: p1 >> pulse(P[0,2,4,6,8,10], sus=.5, chop=8, slide=linvar([0,.6]), oct=5).sometimes("stutter", 6)
Out[60]: <p1 - pulse>

In [61]: za >> zap(PSum(1,2), oct=[4,4.5], amp=3, dur=PDur(7,8)|2, vib=2, crush=8)
Out[61]: <za - zap>

In [62]: za >> zap(PSum(1,2), oct=[4,4.5], amp=3, dur=PDur(7,8), vib=2, crush=8)
Out[62]: <za - zap>

In [63]: p3 >> pulse(oct=[2,3], amp=linvar([.9,2]), dur=PDur(5,8)*(1,2), sus=var([2,6]), hpf=linvar([122,40
    ...: 00]), chop=8)
Out[63]: <p3 - pulse>

In [64]: p1 >> pulse(P[0,2,4,6,8,10], sus=.5, chop=8, slide=linvar([0,.6]), oct=5).sometimes("stutter", 4)
Out[64]: <p1 - pulse>

In [65]: za >> zap(PSum(1,2), oct=linvar([4,4.5]), amp=3, dur=PDur(7,8), vib=2, crush=8)
Out[65]: <za - zap>

In [66]: za >> zap(PSum(1,2), oct=linvar([4,4.5]), amp=3, dur=PDur(8,8), vib=2, crush=8)
Out[66]: <za - zap>

In [67]: p3 >> pulse(oct=[2,3], amp=linvar([.9,2]), dur=PDur(3,8), sus=var([2,6]), hpf=linvar([122,4000]),
    ...: chop=8)
Out[67]: <p3 - pulse>

In [68]: px >> pluck(var([0,3,2,4,1]), pan=[-1,1], dur=[1,.25,.25,.5])
Out[68]: <px - pluck>

In [69]: p1 >> pulse(P[0,2,4,6,8,10], sus=.5, chop=4, slide=linvar([0,.6]), oct=5).sometimes("stutter", 4)
Out[69]: <p1 - pulse>

In [70]: p3 >> pulse(oct=[2,3], amp=linvar([.6,1]), dur=PDur(3,8), sus=var([2,6]), hpf=linvar([122,4000]),
    ...: chop=8)
Out[70]: <p3 - pulse>

In [71]: px >> pluck(var([0,3,2,4,1], 8), pan=[-1,1], dur=[1,.25,.25,.5])
Out[71]: <px - pluck>

In [72]: px >> pluck(var([0,3,2,4,1], 8), pan=[-1,1], dur=[1,.25,.25,.5]) + (0,2,4)
Out[72]: <px - pluck>

In [73]: px >> pluck(var([0,3,2,4,1], 8), pan=[-1,1], dur=PDur(5,9)) + (0,2,4)
Out[73]: <px - pluck>

In [74]: za >> zap(PSum(1,2), oct=linvar([4,4.5]), amp=3, dur=PDur(7,8), vib=2, crush=8)
Out[74]: <za - zap>

In [75]: p1 >> pulse(P[0,2,4,6,8,10], sus=.25, chop=4, slide=linvar([0,.6]), oct=5).sometimes("stutter", 4)
    ...:
Out[75]: <p1 - pulse>

In [76]: px >> pluck(var([0,2,[4,6,7],[3,5,1]], 8), pan=[-1,1], dur=PDur(5,9)) + (0,2,4)
Out[76]: <px - pluck>

In [77]: ~px >> pluck(var([0,2,[4,6,7],[3,5,1]], 8), pan=[-1,1], dur=PDur(5,9)) + (0,2,4)
Out[77]: <px - pluck>

In [78]: px >> pluck(var([0,2,[4,6,7],[3,5,1],(4,2,0)], 8), pan=[-1,1], dur=PDur(5,9)) + (0,2,4)
Out[78]: <px - pluck>

In [79]: px >> pluck(var([0,2,[4,6,7],[3,5,1],(4,2,0)], 8), oct=[4,5], pan=[-1,1], dur=PDur(5,9)) + (0,2,4)
    ...:
Out[79]: <px - pluck>

In [80]: px >> pluck(var([0,2,[4,6,5],[3,5,1],(4,2,0)], 8), oct=[4,5], pan=[-1,1], dur=PDur(5,9)) + (0,2,4)
    ...:
Out[80]: <px - pluck>

In [81]: za >> zap(PSum(1,2), oct=linvar([3,3.5]), amp=3, dur=PDur(8,8), vib=2, crush=8)
Out[81]: <za - zap>

In [82]: za >> zap(PSum(1,2), oct=linvar([4,4.5]), amp=3, dur=PDur(8,8), vib=2, crush=8)
Out[82]: <za - zap>

In [83]: ~px >> karp(var([0,2,[4,6,7],[3,5,1],(4,2,0)], 8), oct=[4,5], pan=[-1,1], sus=2, chop=4, dur=PDur(
    ...: 3,9)) + (0,2,4).solo()
---------------------------------------------------------------------------
AttributeError                            Traceback (most recent call last)
<ipython-input-83-39d09fb471d4> in <module>
----> 1 ~px >> karp(var([0,2,[4,6,7],[3,5,1],(4,2,0)], 8), oct=[4,5], pan=[-1,1], sus=2, chop=4, dur=PDur(3
,9)) + (0,2,4).solo()

AttributeError: 'tuple' object has no attribute 'solo'

In [84]: ~px >> karp(var([0,2,[4,6,7],[3,5,1],(4,2,0)], 8), oct=[4,5], pan=[-1,1], sus=2, chop=4, dur=PDur(
    ...: 3,9)).solo()
Out[84]: <px - karp>

In [85]: x1 >> play("V ", dur=.5)
Out[85]: <x1 - play2>

In [86]: x2 >> play(" |n2|", dur=.5)
Out[86]: <x2 - play2>

In [87]: x4 >> play(" |*1|", dur=1)
Out[87]: <x4 - play2>

In [88]: ~p3 >> sinepad(oct=[2,3], amp=linvar([.9,2]), dur=PDur(3,8), sus=var([2,6]), hpf=linvar([122,4000]
    ...: ), chop=8)
Out[88]: <p3 - sinepad>

In [89]: p1 >> pulse(P[0,2,4,6,8,10], sus=.25, chop=4, slide=linvar([0,.6]), oct=5).sometimes("stutter", 4)
    ...: .stop()
Out[89]: <p1 - pulse>

In [90]: p2 >> dbass(dur=PDur(3,8), oct=4, amp=.3).stop()
Out[90]: <p2 - dbass>

In [91]: b1 >> dirt(oct=4, dur=PDur(5,6)).stop()
Out[91]: <b1 - dirt>

In [92]: ~px >> karp(var([0,2,[4,6,7],[3,5,1],(4,2,0)], 8), oct=[4,5], pan=[-1,1], sus=2, chop=4, dur=PDur(
    ...: 3,9))
Out[92]: <px - karp>

In [93]: ~p3 >> sinepad(oct=[2,3], amp=linvar([.9,2]), dur=PDur(3,8), sus=var([2,6]), hpf=linvar([122,4000]
    ...: ), chop=8)
Out[93]: <p3 - sinepad>

In [94]: x4 >> play(" |*1|", dur=1)
Out[94]: <x4 - play2>

In [95]: ~p3 >> sinepad(amp=linvar([.9,2]), dur=PDur(3,8)*(1,2), sus=var([2,6]), hpf=linvar([122,4000]), ch
    ...: op=8)
Out[95]: <p3 - sinepad>

In [96]: p2 >> dbass(dur=PDur(7,9), oct=[3,5,4], amp=.6)
Out[96]: <p2 - dbass>

In [97]: za >> zap(PSum(1,2), oct=linvar([4,4.5]), amp=3, dur=PDur(8,8), vib=2, crush=8)
Out[97]: <za - zap>

In [98]: za >> zap(PSum(1,2), oct=linvar([4,4.5]), amp=3, dur=PDur(7,8)|2, vib=2, crush=8)
Out[98]: <za - zap>

In [99]: b1 >> dirt(oct=4, dur=PDur(5,6))
Out[99]: <b1 - dirt>

In [100]: ~p3 >> nylon(amp=1, oct=3, dur=PDur(3,8)*(1,2), sus=var([2,6]), hpf=linvar([122,4000]), chop=8)
Out[100]: <p3 - nylon>

In [101]: ~p3 >> nylon(amp=1.3, oct=3, dur=PDur(3,8)*(1,2), sus=var([2,6]), hpf=linvar([122,4000]), chop=8)
     ...:
Out[101]: <p3 - nylon>

In [102]: ~p3 >> nylon(amp=1.5, oct=3, dur=PDur(3,8)*(1,2), sus=var([2,6]), hpf=linvar([122,4000]), chop=8)
     ...:
Out[102]: <p3 - nylon>

In [103]: p2 >> jbass(dur=PDur(7,9), oct=[3,5,4], amp=.6)
Out[103]: <p2 - jbass>

In [104]: ~p2 >> jbass(dur=PDur(7,9), oct=[3,5,4], amp=.6)
Out[104]: <p2 - jbass>

In [105]: za >> zap(PSum(1,2), oct=linvar([4,4.5]), amp=3, dur=PDur(7,8), vib=2, crush=8)
Out[105]: <za - zap>

In [106]: ~p3 >> nylon(amp=1.5, oct=3, dur=PDur(5,8)*(1,2), sus=var([2,6]), hpf=linvar([122,4000]), chop=8)
     ...:
Out[106]: <p3 - nylon>

In [107]: ~p3 >> nylon(amp=1.5, oct=3, dur=PDur(7,8)*(1,2), sus=var([2,6]), hpf=linvar([122,4000]), chop=8)
     ...:
Out[107]: <p3 - nylon>

In [108]: b1 >> dirt(oct=5, dur=PDur(5,6))
Out[108]: <b1 - dirt>

In [109]: ~px >> karp(var([0,2,[4,6,7],[3,5,1],(4,2,0)], 8), oct=[4,5], pan=[-1,1], sus=2, chop=4, dur=PDur
     ...: (3,9)).stop()
Out[109]: <px - karp>

In [110]: ~p3 >> nylon(amp=1.5, oct=[3,4], dur=PDur(7,8)*(1,2), sus=var([2,6]), hpf=linvar([122,4000]), cho
     ...: p=8)
Out[110]: <p3 - nylon>

In [111]: za >> zap(PSum(1,2), oct=linvar([4,4.5]), amp=3, dur=PDur(8,8), vib=2, crush=8)
Out[111]: <za - zap>

In [112]: za >> zap(PSum(1,2), oct=[4,4.5], amp=3, dur=PDur(8,8), vib=2, crush=8)
Out[112]: <za - zap>

In [113]: za >> zap(PSum(1,2), oct=[4,4.5], amp=3, dur=PDur(7,8), vib=2, crush=8)
Out[113]: <za - zap>

In [114]: ~p3 >> nylon(amp=1.5, oct=[3,4], dur=PDur(7,8)*(1,2), sus=var([2,6]), hpf=linvar([122,4000]), cho
     ...: p=4)
Out[114]: <p3 - nylon>

In [115]: b1 >> dirt(oct=5, dur=PDur(5,8))
Out[115]: <b1 - dirt>

In [116]: b1 >> dirt(oct=5, dur=PDur(5,9))
Out[116]: <b1 - dirt>

In [117]: ~p3 >> nylon(amp=1.5, oct=[3,4], dur=PDur(5,8)*(1,2), sus=var([2,6]), hpf=linvar([122,4000]), cho
     ...: p=8)
Out[117]: <p3 - nylon>

In [118]: c1 >> play("@", dur=.25, sample=P[:8].rotate([0,1,3]), rate=4, pan=linvar([-1,1], 16))
Out[118]: <c1 - play2>

In [119]: c1 >> play("@", dur=.25, sample=P[:8].rotate([0,1,3]), rate=4, pan=linvar([-1,1], 16), amp=1.2)
Out[119]: <c1 - play2>

In [120]: p2 >> jbass(dur=PDur(7,9), oct=[3,5,4], amp=.6, sus=2, chop=4)
Out[120]: <p2 - jbass>

In [121]: p2 >> jbass(dur=PDur(7,9), amp=.6, sus=2, chop=4)
Out[121]: <p2 - jbass>

In [122]: ~p2 >> jbass(dur=PDur(7,9), amp=.6, sus=2, chop=4)
Out[122]: <p2 - jbass>

In [123]: ~p3 >> nylon(amp=1.5, oct=[3,4], dur=PDur(3,8)*(1,2), sus=var([2,6]), hpf=linvar([122,4000]), cho
     ...: p=8)
Out[123]: <p3 - nylon>

In [124]: p2 >> jbass(dur=PDur(3,8), amp=.6, sus=2, chop=4)
Out[124]: <p2 - jbass>

In [125]: p2 >> jbass(dur=PDur(3,8), amp=.6, sus=2, chop=4, shape=PWhite(0,.5))
Out[125]: <p2 - jbass>

In [126]: p2 >> jbass(dur=PDur(3,8), amp=.6, sus=2, chop=4, shape=PWhite(0,.5), pan=PWhite(-1,1))
Out[126]: <p2 - jbass>

In [127]: p2 >> jbass(dur=PDur(3,8), amp=.6, sus=2, chop=4, shape=PWhite(0,.5), pan=PWhite(-1,1)).sometimes
     ...: ("offadd", 4)
Out[127]: <p2 - jbass>

In [128]: za >> zap(PSum(1,2), oct=[4,4.5], amp=3, dur=PDur(7,8), vib=2, crush=8).stop()
Out[128]: <za - zap>

In [129]: p2 >> jbass(dur=PDur(3,8), amp=.6, sus=2, chop=4, shape=PWhite(0,.5), pan=PWhite(-1,1)).sometimes
     ...: ("offadd", 4) + var([0,2],4)
Out[129]: <p2 - jbass>

In [130]: p7 >> space(dur=8, pan=(-1,1))
Out[130]: <p7 - space>

In [131]: p7 >> space([7,6,4], dur=8, pan=(-1,1))
Out[131]: <p7 - space>

In [132]: ~p3 >> nylon(amp=1.5, oct=[3,4], dur=PDur(5,8)*(1,2), sus=var([2,6]), hpf=linvar([122,4000]), cho
     ...: p=8)
Out[132]: <p3 - nylon>

In [133]: p7 >> space([7,6,4,P*(2,1),0], dur=8, pan=(-1,1))
Out[133]: <p7 - space>

In [134]: p2 >> jbass(dur=PDur(5,8), amp=.6, sus=2, chop=4, shape=PWhite(0,.5), pan=PWhite(-1,1)).sometimes
     ...: ("offadd", 4) + var([0,2],4)
Out[134]: <p2 - jbass>

In [135]: p2 >> jbass(dur=PDur(5,8), amp=.6, sus=1, chop=4, shape=PWhite(0,.5), pan=PWhite(-1,1)).sometimes
     ...: ("offadd", 4) + var([0,2],4)
Out[135]: <p2 - jbass>

In [136]: p7 >> space([7,6,4,P*(2,1),0], dur=4, pan=(-1,1))
Out[136]: <p7 - space>

In [137]: ~p3 >> nylon(amp=1.5, oct=3, dur=PDur(5,8)*(1,2), sus=var([2,6]), hpf=linvar([122,4000]), chop=8)
     ...:
Out[137]: <p3 - nylon>

In [138]: ~p3 >> nylon(amp=1.5, oct=3, dur=PDur(7,8)*(1,2), sus=var([2,6]), hpf=linvar([122,4000]), chop=8)
     ...:
Out[138]: <p3 - nylon>

In [139]: b1 >> dirt(oct=5, dur=PDur(5,9)).stop()
Out[139]: <b1 - dirt>

In [140]: p7 >> space([7,6,4,P*(2,1),0], dur=8, pan=(-1,1))
Out[140]: <p7 - space>

In [141]: p2 >> jbass(dur=PDur(5,8), amp=.6, sus=1, chop=8, shape=PWhite(0,.5), pan=PWhite(-1,1)).sometimes
     ...: ("offadd", 4) + var([0,2],4)
Out[141]: <p2 - jbass>

In [142]: p2 >> jbass(dur=PDur(5,8), amp=.6, sus=1, chop=4, shape=PWhite(0,.5), pan=PWhite(-1,1)).sometimes
     ...: ("offadd", 4) + var([0,2],4)
Out[142]: <p2 - jbass>

In [143]: c2 >> play("t", echo=var([0,.25], [64,32]), echotime=[.5,.75])
Out[143]: <c2 - play2>

In [144]: c1 >> play("@", dur=.25, sample=P[:8].rotate([0,1,3]), rate=4, pan=linvar([-1,1], 16), amp=1.2)
Out[144]: <c1 - play2>

In [145]: c2 >> play("t", echo=var([0,.25], [64,32]), echotime=[.5,.75], amp=1.5)
Out[145]: <c2 - play2>

In [146]: ~p3 >> nylon(amp=1.5, oct=3, dur=PDur(3,8)*(1,2), sus=var([2,6]), hpf=linvar([122,4000]), chop=8)
     ...:
Out[146]: <p3 - nylon>

In [147]: ~p3 >> nylon(amp=1.5, oct=3, dur=PDur(3,8), sus=var([2,6]), hpf=linvar([122,4000]), chop=8)
Out[147]: <p3 - nylon>

In [148]: c1 >> play("@", dur=.25, sample=P[:8].rotate([0,1,3]), rate=4, pan=linvar([-1,1], 16), amp=1.2)
Out[148]: <c1 - play2>

In [149]: c2 >> play("t", echo=var([0,.25], [64,32]), echotime=[.5,.75], amp=1.5, dur=[.25,.25,.5])
Out[149]: <c2 - play2>

In [150]: c2 >> play("t", echo=var([0,.25], [64,32]), echotime=[.5,.75], amp=2, dur=[.25,.25,.5])
Out[150]: <c2 - play2>

In [151]: p7 >> space([5,6,4,P*(2,1),0], dur=8, pan=(-1,1))
Out[151]: <p7 - space>

In [152]: p7 >> space([5,4,3,P*(2,1),0], dur=8, pan=(-1,1))
Out[152]: <p7 - space>

In [153]: p2 >> jbass(dur=PDur(7,8), amp=.6, sus=1, chop=4, shape=PWhite(0,.5), pan=PWhite(-1,1)).sometimes
     ...: ("offadd", 4) + var([0,2],4)
Out[153]: <p2 - jbass>

In [154]: x4 >> play(" |*1|", dur=1).stop
---------------------------------------------------------------------------
TypeError                                 Traceback (most recent call last)
<ipython-input-154-e6a05fed5bbd> in <module>
----> 1 x4 >> play(" |*1|", dur=1).stop

~/.local/lib/python3.8/site-packages/FoxDot/lib/Players.py in __rshift__(self, other)
    395             return self
    396
--> 397         raise TypeError("{} is an innapropriate argument type for PlayerObject".format(other))
    398
    399         return self

TypeError: <function SynthDefProxy.__getattr__.<locals>.func at 0x7f6ec0507790> is an innapropriate argumen
t type for PlayerObject

In [155]: x4 >> play(" |*1|", dur=1).stop()
Out[155]: <x4 - play2>

In [156]: p2 >> jbass(dur=PDur(3,8), amp=.6, sus=1, chop=4, shape=PWhite(0,.5), pan=PWhite(-1,1)).sometimes
     ...: ("offadd", 4) + var([0,2],4)
Out[156]: <p2 - jbass>

In [157]: ~p3 >> nylon(amp=1.5, oct=3, dur=PDur(3,8)*(1,2), sus=var([2,6]), hpf=linvar([122,4000]), chop=8)
     ...:
Out[157]: <p3 - nylon>

In [158]: x2 >> play(" [ss]", dur=.5)
Out[158]: <x2 - play2>

In [159]: x2 >> play("[ss]", dur=.5)
Out[159]: <x2 - play2>

In [160]: p2 >> jbass(dur=PDur(5,8), amp=.6, sus=1, chop=4, shape=PWhite(0,.5), pan=PWhite(-1,1)).sometimes
     ...: ("offadd", 4) + var([0,2],4)
Out[160]: <p2 - jbass>

In [161]: ~p2 >> dbass(dur=PDur(5,8), amp=.6, sus=1, chop=4, shape=PWhite(0,.5), pan=PWhite(-1,1)).sometime
     ...: s("offadd", 4) + var([0,2],4)
Out[161]: <p2 - dbass>

In [162]: p7 >> space([5,4,3,P*(2,1),0], dur=2, pan=(-1,1))
Out[162]: <p7 - space>

In [163]: ~p3 >> nylon(amp=1.5, oct=3, dur=PDur(3,8), sus=var([2,6]), hpf=linvar([122,4000]), chop=4)
Out[163]: <p3 - nylon>

In [164]: p7 >> space([5,4,3,P*(2,1),0], dur=2, pan=(-1,1)).sometimes("reverse")
Out[164]: <p7 - space>

In [165]: ~p3 >> nylon(amp=1.5, oct=3, dur=PDur(3,8), sus=var([2,6]), hpf=linvar([122,4000]), chop=4).stop(
     ...: )
Out[165]: <p3 - nylon>

In [166]: p7 >> soprano([5,4,3,P*(2,1),0], dur=8, pan=(-1,1)).sometimes("reverse")
Out[166]: <p7 - soprano>

In [167]: p7 >> soprano([5,4,3,P*(2,1),0], dur=8, amp=.9, pan=(-1,1)).sometimes("reverse")
Out[167]: <p7 - soprano>

In [168]: p2 >> dbass(dur=PDur(5,8), amp=.6, sus=1, chop=2, shape=PWhite(0,.5), pan=PWhite(-1,1)).sometimes
     ...: ("offadd", 4) + var([0,2],4)
Out[168]: <p2 - dbass>

In [169]: x2 >> play("[ss]", dur=.5).stop()
Out[169]: <x2 - play2>

In [170]: p2 >> dbass(dur=PDur(5,8), amp=.6, sus=1, chop=4, shape=PWhite(0,.5), pan=PWhite(-1,1)).sometimes
     ...: ("offadd", 4) + var([0,2],4)
Out[170]: <p2 - dbass>

In [171]: p2 >> dbass(dur=PDur(5,8), amp=.6, sus=1, chop=2, shape=PWhite(0,.5), pan=PWhite(-1,1)).sometimes
     ...: ("offadd", 4) + var([0,2],4)
Out[171]: <p2 - dbass>

In [172]: p7 >> soprano([5,4,3,P*(2,1),0], dur=8, amp=.8, chop=4, pan=(-1,1)).sometimes("reverse")
Out[172]: <p7 - soprano>

In [173]: p7 >> soprano([5,4,3,P*(2,1),0], dur=2, amp=.8, chop=8, pan=(-1,1)).sometimes("reverse")
Out[173]: <p7 - soprano>

In [174]: p1 >> blip(P[0,2,4,6,8,10], sus=.25, slide=linvar([0,.6]), oct=5).sometimes("stutter", 4)
Out[174]: <p1 - blip>

In [175]: ~p1 >> blip(P[0,2,4,6,8,10], sus=.25, slide=linvar([0,.6]), oct=5).sometimes("stutter", 4)
Out[175]: <p1 - blip>

In [176]: p1 >> blip(P[0,2,4,6,8,10], amp=1.2, sus=.25, slide=linvar([0,.6]), oct=5).sometimes("stutter", 4
     ...: )
Out[176]: <p1 - blip>

In [177]: p1 >> blip(P[0,2,4,6,8,10], amp=1.5, sus=.25, slide=linvar([0,.6]), oct=5).sometimes("stutter", 4
     ...: )
Out[177]: <p1 - blip>

In [178]: p7 >> soprano([5,4,3,P*(2,1),0], dur=2, amp=.8, pan=(-1,1)).sometimes("reverse")
Out[178]: <p7 - soprano>

In [179]: ~p7 >> soprano([5,4,3,P*(2,1),0], dur=2, amp=.8, pan=(-1,1)).sometimes("reverse")
Out[179]: <p7 - soprano>

In [180]: p2 >> dbass(dur=PDur(5,8), amp=.6, sus=1, chop=2, shape=PWhite(0,.5), pan=PWhite(-1,1)).sometimes
     ...: ("offadd", 4) + var([0,2],4).stop()
---------------------------------------------------------------------------
AttributeError                            Traceback (most recent call last)
<ipython-input-180-b5f617b5db96> in <module>
----> 1 p2 >> dbass(dur=PDur(5,8), amp=.6, sus=1, chop=2, shape=PWhite(0,.5), pan=PWhite(-1,1)).sometimes("
offadd", 4) + var([0,2],4).stop()

AttributeError: 'TimeVar' object has no attribute 'stop'

In [181]: p2 >> dbass(dur=PDur(5,8), amp=.6, sus=1, chop=2, shape=PWhite(0,.5), pan=PWhite(-1,1)).sometimes
     ...: ("offadd", 4).stop()
Out[181]: <p2 - dbass>

In [182]: x1 >> play("V ", dur=.5).stop()
Out[182]: <x1 - play2>

In [183]: c_all.stop()

In [184]: Clock.clear()

In [185]:
